### hs_office_relationship RBAC

```mermaid

flowchart TB

subgraph global
    style global fill:#eee
    
    role:global.admin[global.admin]    
end

subgraph contact
    direction TB
    style contact fill:#eee
    
    role:contact.owner[contact.admin]
    --> role:contact.admin[contact.admin]
    --> role:contact.referrer[contact.referrer]
end

subgraph anchorPerson
    direction TB
    style anchorPerson fill:#eee
    
    role:anchorPerson.owner[anchorPerson.owner]    
    --> role:anchorPerson.admin[anchorPerson.admin]    
    --> role:anchorPerson.referrer[anchorPerson.referrer]    
end

subgraph holderPerson
    direction TB
    style holderPerson fill:#eee
    
    role:holderPerson.owner[holderPerson.owner]
    --> role:holderPerson.admin[holderPerson.admin]
    --> role:holderPerson.referrer[holderPerson.referrer]
end

subgraph relationship

    role:relationship.owner[relationship.owner]
    %% permissions
        role:relationship.owner --> perm:relationship.*{{relationship.*}}
    %% incoming
        role:global.admin ---> role:relationship.owner
       
    role:relationship.admin[relationship.admin]
    %% permissions
        role:relationship.admin --> perm:relationship.edit{{relationship.edit}}
    %% incoming
        role:relationship.owner --> role:relationship.admin
        role:anchorPerson.admin --> role:relationship.admin
        
    role:relationship.agent[relationship.agent]
    %% incoming
        role:relationship.admin --> role:relationship.agent
        role:holderPerson.admin --> role:relationship.agent
        role:contact.admin --> role:relationship.agent

    role:relationship.tenant[relationship.tenant]
    %% permissions
        role:relationship.tenant --> perm:relationship.view{{relationship.view}}
    %% incoming
        role:relationship.agent --> role:relationship.tenant
    %% outgoing
        role:relationship.tenant --> role:anchorPerson.referrer
        role:relationship.tenant --> role:holderPerson.referrer
        role:relationship.tenant --> role:contact.referrer
        
    %% additional
    role:anchorPerson.admin =="if REPRESENTATIVE"==> role:holderPerson.admin
end
```
